# Wolfpack Runtime Library
#
# General settings

TEMPLATE = lib
CONFIG   = warn_off release staticlib
TARGET   = wrl
VERSION  = 3.0.2
DESTDIR  = lib
INCLUDEPATH = include include/private
# Common sources

SOURCES =  \
                src/cmdline.cpp \
		src/preferences.cpp \
                src/qapplication.cpp \
		src/qbitarray.cpp \
		src/qbuffer.cpp \
		src/qcstring.cpp \
		src/qdatastream.cpp \
		src/qdatetime.cpp \
		src/qdir.cpp \
		src/qdom.cpp \
		src/qfile.cpp \
                src/qfileinfo.cpp \
		src/qgarray.cpp \
		src/qgcache.cpp \
		src/qgdict.cpp \
		src/qglist.cpp \
		src/qglobal.cpp \
		src/qgpluginmanager.cpp \
		src/qgvector.cpp \
                src/qhostaddress.cpp \
		src/qiodevice.cpp \
		src/qlibrary.cpp \
		src/qmap.cpp \
		src/qptrcollection.cpp \
		src/qregexp.cpp \
                src/qsocketdevice.cpp \
		src/qstring.cpp \
		src/qstringlist.cpp \
		src/qtranslator.cpp \
		src/qtextstream.cpp \
		src/quuid.cpp \
		src/qxml.cpp

HEADERS =  \
                include/cmdline.h \
		include/preferences.h \
		include/qasciidict.h \
                include/qapplication.h \
		include/qbitarray.h \
		include/qbuffer.h \
		include/qcache.h \
		include/qcleanuphandler.h \
		include/qconfig.h \
		include/qcstring.h \
		include/qdatastream.h \
		include/qdatetime.h \
		include/qdict.h \
		include/qdir.h \
		include/private/qdir_p.h \
                include/qdom.h \
		include/qfeatures.h \
		include/qfile.h \
                include/qfiledefs_p.h \
		include/qfileinfo.h \
		include/qgarray.h \
		include/qgcache.h \
		include/qgdict.h \
		include/qglist.h \
		include/qglobal.h \
                include/qhostaddress.h \
		include/qgvector.h \
		include/qintdict.h \
		include/qiodevice.h \
		include/qlibrary.h \
		include/qmap.h \
		include/qmemarray.h \
		include/qmodules.h \
		include/qnamespace.h \
		include/qpair.h \
		include/qptrcollection.h \
                include/qptrdict.h \
		include/qptrlist.h \
		include/qptrstack.h \
		include/qptrvector.h \
		include/qregexp.h \
		include/qshared.h \
                include/qsocketdevice.h \
		include/qstring.h \
		include/qstringlist.h \
		include/qstrlist.h \
		include/qt_windows.h \
		include/qtextstream.h \
		include/qtl.h \
                include/qtranslator.h \
		include/quuid.h \
		include/qvaluelist.h \
		include/qvaluestack.h \
                include/qvaluevector.h \
		include/private/qgpluginmanager_p.h \
		include/private/qlibrary_p.h \
		include/private/qpluginmanager_p.h \
                include/qxml.h 



# Platform Specific stuff

#
# Win32:
#*******

win32-msvc:TMAKE_CXXFLAGS = /EHsc
win32-msvc:INCLUDEPATH += include/platform/win32-msvc
win32-borland:INCLUDEPATH += include/platform/win32-borland
win32-g++:INCLUDEPATH += include/platform/win32-g++

win32-msvc:HEADERS += include/platform/win32-msvc/qplatformdefs.h
win32-borland:HEADERS += include/platform/win32-borland/qplatformdefs.h
win32-g++:HEADERS += include/platform/win32-g++/qplatformdefs.h

win32:SOURCES += \
		src/qdir_win.cpp \
		src/qfile_win.cpp \
                src/qfileinfo_win.cpp \
                src/qlibrary_win.cpp \
                src/qsocketdevice_win.cpp


#
# Linux
#******

unix:INCLUDEPATH += include/platform/linux-g++
unix:HEADERS += include/platform/linux-g++/qplatformdefs.h
unix:SOURCES += \
		src/qdir_unix.cpp \
		src/qfile_unix.cpp \
                src/qfileinfo_unix.cpp \
                src/qlibrary_unix.cpp \
                src/qsocketdevice_unix.cpp 

#
# BSD
#*****
bsd:INCLUDEPATH += include/platform/linux-g++
bsd:HEADERS += include/platform/linux-g++/qplatformdefs.h
bsd:SOURCES += \
		src/qdir_unix.cpp \
		src/qfile_unix.cpp \
                src/qfileinfo_unix.cpp \
                src/qlibrary_unix.cpp \
                src/qsocketdevice_unix.cpp 
