//==================================================================================
//
//      UOFree emu
//	UO Server Emulation Program
//
//	Copyright 2004 by pyj200
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	* In addition to that license, if you are running this program or modified
//	* versions of it on a public system you HAVE TO make the complete source of
//	* the version used by you available or provide people with a location to
//	* download it.
//
//========================================================================================
//Directives
#if !defined(IN_NETSYS_H)
#define IN_NETSYS_H
//========================================================================
//Platform Specs
#include "platform.h"
//========================================================================
//System Files

#include <iostream>
#include <string>

#if defined(_POSIX)
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <sys/errno.h>
#include <sys/time.h>
#include <sys/select.h>
#include <signal.h>
#include <cstdio>
// NETWORK DEFINES
#define closesocket(s)  close(s) 
//doesnt have the new gethostbyname2
#define gethostbyname2(host,family) gethostbyname(host)
// But does have the inet_pton and inet_ntop
#define IPV6
// Correspond to Windows error symbol
#define SOCKET_ERROR -1
// ioctl is just ioctl under unix
#define ioctlsocket ioctl
//  in case inet_addr returns an error (compat with windows)
#define INET_ADDR 0

#define WSAECONNRESET EPIPE
void signal_handler(int) ;

#elif defined(WIN32)

#include <winsock2.h>
#include <ws2tcpip.h>
// NETWORK defines
#define SHUT_RDWR SD_BOTH
#define socklen_t  int FAR 
#define in_addr_t  UI32
#define bzero(ptr,n)				memset(ptr,0,n)
#define gethostbyname2(host,family) gethostbyname(host)
#endif
#ifndef MSG_NOSIGNAL
// windows and BSD's dont have this, so set to zero 
#define MSG_NOSIGNAL 0
#endif

#ifndef in_addr_t
#define in_addr_t UI32
#endif


using namespace std;
//========================================================================
// backlog setting
#define NETBACKLOG 512
// Protocol setting
#define IP_PROTOCOL 0 
//=========================================================================
// prototype some usefule network functions we will use
string	sock_ntop(sockaddr_in ) ;
string  sock_ntop(in_addr_t) ;
UI32	sock_pton(string ) ;
SI32	sock_error(SI32 siStatus, SI32 siErrno) ;
SI32	sock_size(SI32 siSocket) ;
SI32	sock_linger(SI32 siSocket,bool bLinger=false) ;
SI32	sock_flush(SI32 siSocket);
UI32	getDNS(string sIP) ;
bool	networkinit() ;
//=========================================================================
//=========================================================================
//=====================  End of netsys.h  =================================
//=========================================================================
//=========================================================================
#endif
