//==================================================================================
//
//      UOFree emu
//	UO Server Emulation Program
//
//	Copyright 2004 by pyj200
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	* In addition to that license, if you are running this program or modified
//	* versions of it on a public system you HAVE TO make the complete source of
//	* the version used by you available or provide people with a location to
//	* download it.
//
//========================================================================================

#if !defined (__UOBJECT_H__)
#define __UOBJECT_H__

#include "platform.h"
#include "typedefs.h"
#include "coord.h"

// System includes
#include <string>

// Forward class declarations
class ISerialization;
class Coord_cl;

class cUObject
{
// Data Members
public:
	SERIAL serial;
	SERIAL multis;
	bool free;

	std::string name;
	Coord_cl pos;
// Methods
protected:
	void init();
public:
	cUObject();
	cUObject( cUObject& ); // Copy constructor
	virtual ~cUObject() {}
	virtual void Serialize(ISerialization &archive);
	virtual std::string objectID() = 0;
	void moveTo( const Coord_cl& );
};

#endif // __UOBJECT_H__
