//==================================================================================
//
//      UOFree emu
//	UO Server Emulation Program
//
//	Copyright 2004 by pyj200
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	* In addition to that license, if you are running this program or modified
//	* versions of it on a public system you HAVE TO make the complete source of
//	* the version used by you available or provide people with a location to
//	* download it.
//
//========================================================================================
//Directives
#ifndef	IN_UTILSYS_H
#define IN_UTILSYS_H
//========================================================================
//Platform Specs
#include "platform.h"
//========================================================================
//System Files

#include <iostream>
#include <string>
#include <vector>
#include <cstdio>

#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
// Includes we need for time handling
#if defined(OBSOLETETIME)
#include <sys/timeb.h>
#else
#include <sys/time.h>
#include <unistd.h>
#endif
// Includes we need for directory manipulation 
#if defined(_POSIX)
#include <dirent.h>
#include <glob.h>
#include <unistd.h>
#define _stat stat
#define _mkdir mkdir
#define _rmdir rmdir
#elif defined(WIN32)
#include <direct.h>
#include <io.h>
#define _mkdir(a,b) _mkdir(a)
#if defined(_MSC_VER)
#define S_ISDIR(m) m&_S_IFDIR
#define mode_t int
#endif
#if defined(__BORLANDC__)
#define mode_t int
#endif
#endif
using namespace std;
//=========================================================================
//Prototypes
UI32 getNormalizedTime() ;
UI32 getPlatformTime() ;
UI32 getPlatformDay() ;
string getRealTimeString() ;
bool makeDirectory(string sDirectory) ;
bool isDirectory(string sDirectory) ;
vector<string> listDirectory(string sDirectory) ;
bool deleteDirectory(string sDirectory) ;
bool deleteFile(string sFile) ;
//========================================================================
//========================================================================
//=======================  End of utilsys.h  ===============================
//========================================================================
//========================================================================
#endif

